=== debian/changelog ===
dpkg (1.20.12+rpi1) bullseye-staging; urgency=medium

  [changes brought forward from 1.20.5+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Sun, 02 Aug 2020 12:08:02 +0000]
  * Hack up Vendor.pm so it doesn't fail
    (see https://lists.debian.org/debian-dpkg/2020/08/msg00004.html )
  * disable testsuite.

 -- Raspbian forward porter <root@raspbian.org>  Tue, 13 Sep 2022 03:09:19 +0000
