=== debian/changelog ===
dpkg (1.20.13) bullseye; urgency=medium

  [ Guillem Jover ]
  * libdpkg: Refactor pkg_format_print() out from pkg_format_show().
  * libdpkg: Handle missing Version when formatting source:Upstream-Version.
    Reported by John Scott <jscott@posteo.net>.
  * libdpkg: Fix varbuf memory leak in pkg_source_version().
  * Architecture support:
    - Add support for loong64 CPU.
      Based on a patch by 张丹丹 <zhangdandan@loongson.cn>. Closes: #1023486
  * Test suite:
    - Add new pkg-format unit tests.

 -- Guillem Jover <guillem@debian.org>  Wed, 13 Sep 2023 23:38:21 +0200
