## dpkg 1.20.13pureos1.1

=== debian/changelog ===
dpkg (1.20.13pureos1.1) byzantium; urgency=medium

  * Reupload after `make dist`.

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Fri, 01 Nov 2024 09:31:13 +0000

dpkg (1.20.13pureos1) byzantium; urgency=medium

  * Update to latest version from bullseye
    Remaining patch: Add PureOS vendor object

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Fri, 01 Nov 2024 07:07:52 +0100

dpkg (1.20.12pureos1) byzantium; urgency=medium

  * Update to latest version from bullseye
    Remaining patch: Add PureOS vendor object

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Sun, 11 Jun 2023 10:38:34 +0200

dpkg (1.20.9pureos2) byzantium; urgency=medium

  * Makefile.am: Add debian/gbp.conf to EXTRA_DIST
  * Re-upload with package generated by `make dist` to
    fix build error on laniakea.
  * Remaining PureOS patch: Add PureOS vendor object

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Wed, 14 Jul 2021 23:27:07 +0200

dpkg (1.20.9pureos1) byzantium; urgency=medium

  * Update to latest version from bullseye
    Remaining patch: Add PureOS vendor object

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Fri, 09 Jul 2021 03:51:10 +0200
